import { sequelize } from '../modules/sequelize.ts';
import { DataTypes, Model } from 'sequelize';

export type RouterCode = {
  id: string;
  path: string;
  key: string;
  active: boolean;
  project: string;
  code: string;
};

export class RouterCodeModel extends Model {
  declare id: string;
  path: string;
  key: string;
  active: boolean;
  project: string;
  public code: string;
}
RouterCodeModel.init(
  {
    id: {
      type: DataTypes.UUID,
      primaryKey: true,
      defaultValue: DataTypes.UUIDV4,
      comment: '用户id',
    },
    path: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    key: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    active: {
      type: DataTypes.BOOLEAN,
      defaultValue: false,
    },
    project: {
      type: DataTypes.STRING,
      defaultValue: 'default',
    },
    code: {
      type: DataTypes.STRING,
      defaultValue: '',
    },
  },
  {
    sequelize,
    tableName: 'cf_router_code',
  },
);
// RouterCodeModel.sync({ alter: true });
